UpgradeIndexMergePolicy (Lucene 3.6.2 API)
Keywords: org.apache.lucene.index.UpgradeIndexMergePolicy class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.index
Class UpgradeIndexMergePolicy

    java.lang.Object
      org.apache.lucene.index.MergePolicy
          org.apache.lucene.index.UpgradeIndexMergePolicy

All Implemented Interfaces:
  Closeable

    public class UpgradeIndexMergePolicy

extends MergePolicy

This `MergePolicy` is used for upgrading all existing segments of an index when calling `IndexWriter.forceMerge(int)`. All other methods delegate to the base `MergePolicy` given to the constructor. This allows for an as-cheap-as possible upgrade of an older index by only upgrading segments that are created by previous Lucene versions. forceMerge does no longer really merge; it is just used to "forceMerge" older segment versions away.

In general one would use `IndexUpgrader`, but for a fully customizeable upgrade, you can use this like any other `MergePolicy` and call `IndexWriter.forceMerge(int)`:

      IndexWriterConfig iwc = new IndexWriterConfig(Version.LUCENE_XX, new KeywordAnalyzer());
      iwc.setMergePolicy(new UpgradeIndexMergePolicy(iwc.getMergePolicy()));
      IndexWriter w = new IndexWriter(dir, iwc);
      w.forceMerge(1);
      w.close();

Warning: This merge policy may reorder documents if the index was partially upgraded before calling forceMerge (e.g., documents were added). If your application relies on "monotonicity" of doc IDs (which means that the order in which the documents were added to the index is preserved), do a forceMerge(1) instead. Please note, the delegate `MergePolicy` may also reorder documents.

See Also:
  `IndexUpgrader`
WARNING: This API is experimental and might change in incompatible ways in the next release.

Nested Class Summary

Nested classes/interfaces inherited from class org.apache.lucene.index.MergePolicy
`MergePolicy.MergeAbortedException, MergePolicy.MergeException, MergePolicy.MergeSpecification, MergePolicy.OneMerge`

Field Summary
`protected MergePolicy` | `base`

Fields inherited from class org.apache.lucene.index.MergePolicy
`writer`

Constructor Summary
`UpgradeIndexMergePolicy(MergePolicy base)` Wrap the given `MergePolicy` and intercept forceMerge requests to only upgrade segments written with previous Lucene versions.

Method Summary
`void` | `close()` Release all resources for the policy.
`MergePolicy.MergeSpecification` | `findForcedDeletesMerges(SegmentInfos segmentInfos)` Determine what set of merge operations is necessary in order to expunge all deletes from the index.
`MergePolicy.MergeSpecification` | `findForcedMerges(SegmentInfos segmentInfos, int maxSegmentCount, Map<SegmentInfo,Boolean> segmentsToMerge)` Determine what set of merge operations is necessary in order to merge to <= the specified segment count.
`MergePolicy.MergeSpecification` | `findMerges(SegmentInfos segmentInfos)` Determine what set of merge operations are now necessary on the index.
`void` | `setIndexWriter(IndexWriter writer)` Sets the `IndexWriter` to use by this merge policy.
`protected boolean` | `shouldUpgradeSegment(SegmentInfo si)` Returns if the given segment should be upgraded.
`String` | `toString()`
`boolean` | `useCompoundFile(SegmentInfos segments, SegmentInfo newSegment)` Returns true if a new segment (regardless of its origin) should use the compound file format.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### base

    protected final MergePolicy base

Constructor Detail

### UpgradeIndexMergePolicy

    public UpgradeIndexMergePolicy(MergePolicy base)

  Wrap the given `MergePolicy` and intercept forceMerge requests to only upgrade segments written with previous Lucene versions.

Method Detail

### shouldUpgradeSegment

    protected boolean shouldUpgradeSegment(SegmentInfo si)

  Returns if the given segment should be upgraded. The default implementation will return `!Constants.LUCENE_MAIN_VERSION.equals(si.getVersion())`, so all segments created with a different version number than this Lucene version will get upgraded.

### setIndexWriter

    public void setIndexWriter(IndexWriter writer)

  Description copied from class: `MergePolicy`
  Sets the `IndexWriter` to use by this merge policy. This method is allowed to be called only once, and is usually set by IndexWriter. If it is called more than once, `SetOnce.AlreadySetException` is thrown.

  Overrides:
    `setIndexWriter` in class `MergePolicy`
  See Also:
    `SetOnce`

### findMerges

    public MergePolicy.MergeSpecification findMerges(SegmentInfos segmentInfos)
                                              throws CorruptIndexException,
                                                     IOException

  Description copied from class: `MergePolicy`
  Determine what set of merge operations are now necessary on the index. `IndexWriter` calls this whenever there is a change to the segments. This call is always synchronized on the `IndexWriter` instance so only one thread at a time will call this method.

  Specified by:
    `findMerges` in class `MergePolicy`
  Parameters:
    `segmentInfos` - the total set of segments in the index
  Throws:
    `CorruptIndexException`
    `IOException`

### findForcedMerges

    public MergePolicy.MergeSpecification findForcedMerges(SegmentInfos segmentInfos,
                                                           int maxSegmentCount,
                                                           Map<SegmentInfo,Boolean> segmentsToMerge)
                                                    throws CorruptIndexException,
                                                           IOException

  Description copied from class: `MergePolicy`
  Determine what set of merge operations is necessary in order to merge to <= the specified segment count. `IndexWriter` calls this when its `IndexWriter.forceMerge(int)` method is called. This call is always synchronized on the `IndexWriter` instance so only one thread at a time will call this method.

  Specified by:
    `findForcedMerges` in class `MergePolicy`
  Parameters:
    `segmentInfos` - the total set of segments in the index
    `maxSegmentCount` - requested maximum number of segments in the index (currently this is always 1)
    `segmentsToMerge` - contains the specific SegmentInfo instances that must be merged away. This may be a subset of all SegmentInfos. If the value is True for a given SegmentInfo, that means this segment was an original segment present in the to-be-merged index; else, it was a segment produced by a cascaded merge.
  Throws:
    `CorruptIndexException`
    `IOException`

### findForcedDeletesMerges

    public MergePolicy.MergeSpecification findForcedDeletesMerges(SegmentInfos segmentInfos)
                                                           throws CorruptIndexException,
                                                                  IOException

  Description copied from class: `MergePolicy`
  Determine what set of merge operations is necessary in order to expunge all deletes from the index.

  Specified by:
    `findForcedDeletesMerges` in class `MergePolicy`
  Parameters:
    `segmentInfos` - the total set of segments in the index
  Throws:
    `CorruptIndexException`
    `IOException`

### useCompoundFile

    public boolean useCompoundFile(SegmentInfos segments,
                                   SegmentInfo newSegment)
                            throws IOException

  Description copied from class: `MergePolicy`
  Returns true if a new segment (regardless of its origin) should use the compound file format.

  Specified by:
    `useCompoundFile` in class `MergePolicy`
  Throws:
    `IOException`

### close

    public void close()

  Description copied from class: `MergePolicy`
  Release all resources for the policy.

  Specified by:
    `close` in interface `Closeable`
  Specified by:
    `close` in class `MergePolicy`

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD